import pizza09 as pz


def test_pizza(capsys):
    pizza = pz.Pizza("dummy pizza", 5.0)
    assert pizza.type == "dummy pizza"
    assert pizza.price == 5.0
    assert len(pizza.extras) == 0

    assert pizza.get_description() == "dummy pizza"

    pizza.add_extra("topping 1", 1.0)
    assert pizza.get_description() == "dummy pizza with extra topping 1"
    assert pizza.price == 6.0

    pizza.add_extra("topping 1", 1.0)
    assert pizza.get_description() == "dummy pizza with extra topping 1"
    assert pizza.price == 6.0

    pizza.add_extra("topping 2", 2.0)
    assert pizza.get_description() == "dummy pizza with extra topping 1, topping 2"
    assert pizza.price == 8.0

    pizza.remove_extra("topping 1", 1.0)
    assert pizza.get_description() == "dummy pizza with extra topping 2"
    assert pizza.price == 7.0

    pizza.remove_extra("topping 1", 1.0)
    assert pizza.get_description() == "dummy pizza with extra topping 2"
    assert pizza.price == 7.0

    with capsys.disabled():
        print()
        print(f"tested {pizza.__class__.__name__} successfully")
